## Standard simulation codes in R, without using MPI

source("\\\\stat.ad.ncsu.edu\\Redirect\\bjreich\\Desktop\\SimStuff\\MCMC.R")
##source("\\\\stat.ad.ncsu.edu\\Redirect\\bjreich\\Documents\\CAL2\\MCMC2.R")
load("\\\\stat.ad.ncsu.edu\\Redirect\\bjreich\\Desktop\\SimStuff\\data.RData")

## Change the model here; model = 1,2,3,4
model<- 4

filename<-paste("Sim",model,".RData",sep="")


nsubs<-100
nsims<-50
iters<-5000
burn<-1000
update<-100000
beta<-c(0,0,0,0,.2,.2,.4,.4)
sige<-.5 #error sd
sigs<-.5

if(F){
 s<-s[1:84,]
 FE<-FE[1:84,]
 toothnum<-toothnum[1:84]
 ZMISS<-ZMISS[,1:84]
 ZMISS<-ZMISS[1:14,]
}


if(T){
 s<-s[1:42,]
 FE<-FE[1:42,]
 toothnum<-toothnum[1:42]
 ZMISS<-ZMISS[,1:42]
 ZMISS<-ZMISS[1:7,]
}


ZMISS<-ZMISS/6
p<-length(beta)
ns<-nrow(s)
nm<-nrow(ZMISS)


library("mvtnorm")
print("model")
print(model)



corYZ<-ifelse(model==1 | model==3,0,1)
sdY<-1
sdZ<-1
corY<-.1
corZ<-.1
mu<-rep(0,8)
S<-diag(8)
S[1:4,1:4]<-sdY*sdY*((1-corY)*diag(4)+corY)
S[5:8,5:8]<-sdZ*sdZ*((1-corZ)*diag(4)+corZ)

beta.mn<-beta.l<-beta.u<-array(0,c(p,4,nsims))

d<-as.matrix(dist(s),upper=T,diag=T)
P<-sigs*t(chol(exp(-0.5*d^2)))
P<-sigs*exp(-0.5*d^2)



for(sim in 1:nsims){
 print("Starting sim #")
 print(sim)

# set.seed(0820*sim)

 x<-matrix(rnorm(nsubs*p),nsubs,p)
 xb<-x%*%beta
 CAL<-y<-mn<-matrix(0,ns,nsubs)
 MISS<-Z<-matrix(0,nm,nsubs)
 theta<-matrix(0,8,nsubs)
  
 for(j in 1:nsubs){
  theta[,j]<-rmvnorm(1,mu[1:4],S[1:4,1:4])
  if(model>2){theta[,j]<-(qgamma(pnorm(theta[,j]/sdY),1,1)-1)/sqrt(1)}
  theta[,j]<-theta[,j]
  spatial<-P%*%rnorm(ns)

  mn[,j]<-xb[j]+FE%*%theta[1:4,j]+spatial
  CAL[,j]<-y[,j]<-mn[,j]+sige*rnorm(ns)
  Z[,j]<-ZMISS%*%(FE%*%mu[5:8]+corYZ*mn[,j])+
         rnorm(nm)  
  MISS[,j]<-ifelse(Z[,j]>0,1,0)
  ZZZ<-MISS[,j]%*%(ZMISS)
  CAL[ZZZ>0,j]<-NA
 }


par(mfrow=c(2,2))
hist(y,breaks=25)
pctmiss<-colMeans(is.na(CAL))
mnCAL<-colMeans(CAL,na.rm=T)
mnY<-colMeans(y,na.rm=T)

plot(pctmiss)
plot(pctmiss,mnCAL)
plot(pctmiss,mnY)
print(mean(is.na(CAL)))

print(summary(lm(mnY~pctmiss)))
print(summary(lm(mnCAL~x+pctmiss)))
print(mean(is.na(CAL)))

traceplot<-function(y,miss,nt){
   ns<-nrow(y)
   plot(y[,1],type="l",ylim=range(y))
   points(y[,1],cex=miss[,1])
   for(j in 1:nt){
     lines(y[,j],col=j)
     points(y[,j],col=j,cex=miss[,j])
   }
} 

traceplot(y,is.na(CAL),20)

if(T){
 fit1<-KC(CAL,X=x,FE=FE,s=s,
         MISS=MISS,ZMISS=ZMISS,
         J=1,infomiss=F,tooth=toothnum,
         iters=iters,burn=burn,display=update)
# fit1<-REinfomiss(CAL,X=x,FE=FE,s=s,
#         MISS=MISS,ZMISS=ZMISS,
#         J=1,infomiss=F,
#         iters=iters,burn=burn,display=update)
 beta.mn[,1,sim]<-apply(fit1$beta[burn:iters,],2,mean)
 beta.l[,1,sim]<-apply(fit1$beta[burn:iters,],2,quantile,0.05)
 beta.u[,1,sim]<-apply(fit1$beta[burn:iters,],2,quantile,0.95)
}

if(T){
 fit2<-KC(CAL,X=x,FE=FE,s=s,
         MISS=MISS,ZMISS=ZMISS,
         J=10,infomiss=F,tooth=toothnum,
         iters=iters,burn=burn,display=update)
 beta.mn[,2,sim]<-apply(fit2$beta[burn:iters,],2,mean)
 beta.l[,2,sim]<-apply(fit2$beta[burn:iters,],2,quantile,0.05)
 beta.u[,2,sim]<-apply(fit2$beta[burn:iters,],2,quantile,0.95)
}

if(T){
 fit3<-KC(CAL,X=x,FE=FE,s=s,
         MISS=MISS,ZMISS=ZMISS,tooth=toothnum,
         J=1,infomiss=T,
         iters=iters,burn=burn,display=update)
 beta.mn[,3,sim]<-apply(fit3$beta[burn:iters,],2,mean)
 beta.l[,3,sim]<-apply(fit3$beta[burn:iters,],2,quantile,0.05)
 beta.u[,3,sim]<-apply(fit3$beta[burn:iters,],2,quantile,0.95)
}

if(T){
 fit4<-KC(CAL,X=x,FE=FE,s=s,tooth=toothnum,
         MISS=MISS,ZMISS=ZMISS,
         J=10,infomiss=T,
         iters=iters,burn=burn,display=update)
 beta.mn[,4,sim]<-apply(fit4$beta[burn:iters,],2,mean)
 beta.l[,4,sim]<-apply(fit4$beta[burn:iters,],2,quantile,0.05)
 beta.u[,4,sim]<-apply(fit4$beta[burn:iters,],2,quantile,0.95)
}
# save.image(filename)
}

#rm(fit1,fit2,fit3,fit4)

beta.mse<-beta.cov<-beta.pow<-matrix(0,p,4)

rownames(beta.mse)<-rownames(beta.cov)<-rownames(beta.pow)<-paste("beta",1:p)
colnames(beta.mse)<-colnames(beta.cov)<-colnames(beta.pow)<-
  c("Simple spatial","NG Spatial","Gauss - Info miss","Full")


for(j in 1:p){for(k in 1:4){
   beta.mse[j,k]<-mean((beta[j]-beta.mn[j,k,1:nsims])^2)
   beta.cov[j,k]<-mean((beta[j]>beta.l[j,k,1:nsims]) & (beta[j]<beta.u[j,k,1:nsims]))
   beta.pow[j,k]<-mean((beta.l[j,k,1:nsims]>0) | (beta.u[j,k,1:nsims]<0))
}}




print("MSE")
print(round(100*beta.mse,2))

print("Power")
print(round(100*beta.pow,2))

print("Coverage")
print(round(100*beta.cov,2))

print("Total MSE")
print(round(100*colMeans(beta.mse),2))

print("Total Cov")
print(round(100*colMeans(beta.cov),2))

save.image(filename)
