nsubs<- 100

mpi.bcast.Robj2slave(nsubs)

nsims<- 100


mpi.bcast.Robj2slave(nsims)


beta <- c(0, 0.2, 0.4)



mpi.bcast.Robj2slave(beta)

p<-length(beta)


mpi.bcast.Robj2slave(p)



traceplot<-function(y,miss,nt){
   ns<-nrow(y)
   plot(y[,1],type="l",ylim=range(y))
   points(y[,1],cex=miss[,1])
   for(j in 1:nt){
     lines(y[,j],col=j)
     points(y[,j],col=j,cex=miss[,j])
   }
} 


mpi.bcast.Robj2slave(traceplot)


callSim <- function() { #Added
	library(MCMCpack)
	library(hbmem)
	library("mvtnorm")
	load("./data.RData")

	rank <- mpi.comm.rank() #Added
	size <- mpi.comm.size() #Added
	size <- size - 1 #Added WHY IS THIS NEEDED?

	# model<-4  # This is commented as it's pulled in from callsim#.R

	filename<-paste("Node.",rank,".RData",sep="") #Changed


	iters<-3000
	burn<- 1000   #This was originally 4000


	
        update<-100000

	sige<-.5 #error sd
	sigs<-.5

	if(F){
	 s<-s[1:84,]
	 FE<-FE[1:84,]
	 toothnum<-toothnum[1:84]
	 ZMISS<-ZMISS[,1:84]
	 ZMISS<-ZMISS[1:14,]
	}


	if(T){
	 s<-s[1:42,]
	 FE<-FE[1:42,]
	 toothnum<-toothnum[1:42]
	 ZMISS<-ZMISS[,1:42]
	 ZMISS<-ZMISS[1:7,]
	}


	ZMISS<-ZMISS/6
	ns<-nrow(s)
	nm<-nrow(ZMISS)


	corYZ<-ifelse(model==1 | model==3,0,0.5)
	sdY<-1
	sdZ<-1
	corY<-.1
	corZ<-.1
	mu<-rep(0,8)
	S<-diag(8)
	S[1:4,1:4]<-sdY*sdY*((1-corY)*diag(4)+corY)
	S[5:8,5:8]<-sdZ*sdZ*((1-corZ)*diag(4)+corZ)

	beta.mn<-beta.l<-beta.u<-array(0,c(p,4,nsims))
	
        #beta.mn<-beta.l<-beta.u<-array(0,c(p,4,1))
	
        ArrayLocation <- 1

	d<-as.matrix(dist(s),upper=T,diag=T)
	P<-sigs*t(chol(exp(-0.5*d^2)))  #orginally, it was exp(-d)
	P<-sigs*exp(-0.5*d^2) #This overwrites the above...



	#Original Line for (sim in 1:nsims) {
	
       for (sim in seq(rank, nsims, by=size)) {

		print(paste("Simulation Number (", sim, ")"))
		innerFilename = paste("Simulation.", sim, ".RData", sep="")

		# set.seed(0820*sim)
		x<-matrix(rnorm(nsubs*p),nsubs,p)
		xb<-x%*%beta
		CAL<-y<-mn<-matrix(0,ns,nsubs)
		MISS<-Z<-matrix(0,nm,nsubs)
		theta<-matrix(0,8,nsubs)
		  
		for(j in 1:nsubs){
			theta[,j]<-rmvnorm(1,mu[1:4],S[1:4,1:4])
			if(model>2){theta[,j]<-(qgamma(pnorm(theta[,j]/sdY),1,1)-1)/sqrt(1)}
			theta[,j]<-theta[,j]
			spatial<-P%*%rnorm(ns)

			mn[,j]<-xb[j]+FE%*%theta[1:4,j]+spatial
			CAL[,j]<-y[,j]<-mn[,j]+sige*rnorm(ns)
			Z[,j]<-ZMISS%*%(FE%*%mu[5:8]+corYZ*mn[,j])+
			rnorm(nm)  
			MISS[,j]<-ifelse(Z[,j]>0,1,0)
			ZZZ<-MISS[,j]%*%(ZMISS)
			CAL[ZZZ>0,j]<-NA
		}


		## par(mfrow=c(2,2))
		## hist(y,breaks=25)
		pctmiss<-colMeans(is.na(CAL))
		mnCAL<-colMeans(CAL,na.rm=T)
		mnY<-colMeans(y,na.rm=T)

		## plot(pctmiss)
		## plot(pctmiss,mnCAL)
		## plot(pctmiss,mnY)
		print(mean(is.na(CAL)))

		print(summary(lm(mnY~pctmiss)))
		print(summary(lm(mnCAL~x+pctmiss)))
		print(mean(is.na(CAL)))


		#traceplot(y,is.na(CAL),20)

		if(T) {
			fit1<-KC(CAL,X=x,FE=FE,s=s,
				MISS=MISS,ZMISS=ZMISS,
				J=1,infomiss=F,tooth=toothnum,
				iters=iters,burn=burn,display=update)
			beta.mn[,1,ArrayLocation]<-apply(fit1$beta[burn:iters,],2,mean)
			beta.l[,1,ArrayLocation]<-apply(fit1$beta[burn:iters,],2,quantile,0.05)
			beta.u[,1,ArrayLocation]<-apply(fit1$beta[burn:iters,],2,quantile,0.95)


			fit2<-KC(CAL,X=x,FE=FE,s=s,
				MISS=MISS,ZMISS=ZMISS,
				J=10,infomiss=F,tooth=toothnum,
				iters=iters,burn=burn,display=update)
			beta.mn[,2,ArrayLocation]<-apply(fit2$beta[burn:iters,],2,mean)
			beta.l[,2,ArrayLocation]<-apply(fit2$beta[burn:iters,],2,quantile,0.05)
			beta.u[,2,ArrayLocation]<-apply(fit2$beta[burn:iters,],2,quantile,0.95)


			fit3<-KC(CAL,X=x,FE=FE,s=s,
				MISS=MISS,ZMISS=ZMISS,tooth=toothnum,
				J=1,infomiss=T,
				iters=iters,burn=burn,display=update)
			beta.mn[,3,ArrayLocation]<-apply(fit3$beta[burn:iters,],2,mean)
			beta.l[,3,ArrayLocation]<-apply(fit3$beta[burn:iters,],2,quantile,0.05)
			beta.u[,3,ArrayLocation]<-apply(fit3$beta[burn:iters,],2,quantile,0.95)


			fit4<-KC(CAL,X=x,FE=FE,s=s,tooth=toothnum,
				MISS=MISS,ZMISS=ZMISS,
				J=10,infomiss=T,
				iters=iters,burn=burn,display=update)
			beta.mn[,4,ArrayLocation]<-apply(fit4$beta[burn:iters,],2,mean)
			beta.l[,4,ArrayLocation]<-apply(fit4$beta[burn:iters,],2,quantile,0.05)
			beta.u[,4,ArrayLocation]<-apply(fit4$beta[burn:iters,],2,quantile,0.95)

			ArrayLocation <- ArrayLocation + 1
		}
		save.image(innerFilename)
	}

	#rm(fit1,fit2,fit3,fit4)
	
	save.image(filename)
	return(list(numProcessed=ArrayLocation, mn=beta.mn, l=beta.l, u=beta.u))
}



source("./MCMC.R")
mpi.bcast.Robj2slave(callSim)
Results <- mpi.remote.exec(callSim())

beta.mse<-beta.cov<-beta.pow<-matrix(0,p,4)
rownames(beta.mse)<-rownames(beta.cov)<-rownames(beta.pow)<-paste("beta",1:p)
colnames(beta.mse)<-colnames(beta.cov)<-colnames(beta.pow)<- c("Simple spatial","NG Spatial","Gauss - Info miss","Full")
beta.mn<-beta.l<-beta.u<-array(0,c(p,4,nsims))


ArrayLocation <- 1 
for (Result in Results) {
	if (is.list(Result)) {	
		NumProcessed <- (Result$numProcessed - 1)
		for (i in 1:NumProcessed) {
			beta.mn[ , , ArrayLocation] <- Result$mn[ , , i]
			beta.l[ , , ArrayLocation] <-  Result$l[ , , i]
			beta.u[ , , ArrayLocation] <-  Result$u[ , , i]
			ArrayLocation <- ArrayLocation + 1
		}
	}
}



#save.image("masterWithResults.RData")

#browser()

#print(Results)
#print(beta.mn)
#print(beta.l)
#print(beta.u)




for(j in 1:p){
	for(k in 1:4){
	   beta.mse[j,k]<-mean((beta[j]-beta.mn[j,k,1:nsims])^2)
	   beta.cov[j,k]<-mean((beta[j]>beta.l[j,k,1:nsims]) & (beta[j]<beta.u[j,k,1:nsims]))
	   beta.pow[j,k]<-mean((beta.l[j,k,1:nsims]>0) | (beta.u[j,k,1:nsims]<0))
	}
}



print("MSE")
print(round(100*beta.mse,3))

print("Power")
print(round(100*beta.pow,3))

print("Coverage")
print(round(100*beta.cov,3))

print("Total MSE")
print(round(100*colMeans(beta.mse),3))


print("SD of MSE")
print(round(100*sd(beta.mse)/sqrt(nsims),3))


print("Total Cov")
print(round(100*colMeans(beta.cov),3))



print("Time required")
print(proc.time())
